using System.Windows;

namespace TestProject
{
    /// <summary>
    /// Ǹ ޽ ̽
    /// </summary>
    public abstract class CylindricalMeshBase : MeshGeneratorBase
    {
        //////////////////////////////////////////////////////////////////////////////////////////////////// Field
        ////////////////////////////////////////////////////////////////////////////////////////// Static
        //////////////////////////////////////////////////////////////////////////////// Public

        #region Field

        /// <summary>
        ///  Ӽ
        /// </summary>
        public static readonly DependencyProperty LengthProperty = DependencyProperty.Register
        (
            "Length",
            typeof(double),
            typeof(CylindricalMeshBase),
            new PropertyMetadata(1.0, PropertyChanged)
        );

        /// <summary>
        /// ݰ
        /// </summary>
        public static readonly DependencyProperty RadiusProperty = DependencyProperty.Register
        (
            "Radius",
            typeof(double),
            typeof(CylindricalMeshBase),
            new PropertyMetadata(1.0, PropertyChanged)
        );

        /// <summary>
        /// ̽  Ӽ
        /// </summary>
        public static readonly DependencyProperty SliceCountProperty = DependencyProperty.Register
        (
            "SliceCount",
            typeof(int),
            typeof(CylindricalMeshBase),
            new PropertyMetadata(36, PropertyChanged),
            ValidateSliceCount
        );

        /// <summary>
        ///   Ӽ
        /// </summary>
        public static readonly DependencyProperty StackCountProperty = DependencyProperty.Register
        (
            "StackCount",
            typeof(int),
            typeof(CylindricalMeshBase),
            new PropertyMetadata(1, PropertyChanged),
            ValidateStackCount
        );

        #endregion

        //////////////////////////////////////////////////////////////////////////////////////////////////// Property
        ////////////////////////////////////////////////////////////////////////////////////////// Public

        #region  - Length

        /// <summary>
        /// 
        /// </summary>
        public double Length
        {
            set
            {
                SetValue(LengthProperty, value);
            }
            get
            {
                return (double)GetValue(LengthProperty);
            }
        }

        #endregion
        #region ݰ - Radius

        /// <summary>
        /// ݰ
        /// </summary>
        public double Radius
        {
            set
            {
                SetValue(RadiusProperty, value);
            }
            get
            {
                return (double)GetValue(RadiusProperty);
            }
        }

        #endregion
        #region ̽  - SliceCount

        /// <summary>
        /// ̽ 
        /// </summary>
        public int SliceCount
        {
            set
            {
                SetValue(SliceCountProperty, value);
            }
            get
            {
                return (int)GetValue(SliceCountProperty);
            }
        }

        #endregion
        #region   - StackCount

        /// <summary>
        ///  
        /// </summary>
        public int StackCount
        {
            set
            {
                SetValue(StackCountProperty, value);
            }
            get
            {
                return (int)GetValue(StackCountProperty);
            }
        }

        #endregion

        //////////////////////////////////////////////////////////////////////////////////////////////////// Method
        ////////////////////////////////////////////////////////////////////////////////////////// Static
        //////////////////////////////////////////////////////////////////////////////// Private

        #region ̽  Ἲ üũϱ - ValidateSliceCount(sourceObject)

        /// <summary>
        /// ̽  Ἲ üũϱ
        /// </summary>
        /// <param name="sourceObject">ҽ ü</param>
        /// <returns>ó </returns>
        private static bool ValidateSliceCount(object sourceObject)
        {
            return (int)sourceObject > 2;
        }

        #endregion
        #region   Ἲ üũϱ - ValidateStackCount(sourceObject)

        /// <summary>
        ///   Ἲ üũϱ
        /// </summary>
        /// <param name="sourceObject">ҽ ü</param>
        /// <returns>ó </returns>
        private static bool ValidateStackCount(object sourceObject)
        {
            return (int)sourceObject > 0;
        }

        #endregion
    }
}